%     FASTENER DOCTOR - программа для лечения и конвертации крепежа
%     Copyright (C) 2018  Михаил Козлов
%     Сайт проекта: <http://www.fastenerdoctor.ru/>
%     Адрес электронной почты для связи с разработчиком:
%     <doctor.fastener@gmail.com>
% 
%     Эта программа является свободным программным обеспечением: Вы можете
%     распространять ее и/или изменять, соблюдая условия Универсальной общественной
%     лицензии GNU, опубликованной Фондом свободного программного обеспечения,
%     либо редакции 3, либо (на Ваше усмотрение) любой редакции, выпущенной позже.
% 
%     Эта программа распространяется в надежде на то, что она окажется полезной,
%     но БЕЗ КАКИХ-ЛИБО ГАРАНТИЙ, включая даже подразумеваемую гарантию ТОВАРНОЙ ПРИГОДНОСТИ,
%     либо ПРИГОДНОСТИ ДЛЯ ОПРЕДЕЛЕННЫХ ЦЕЛЕЙ. Ознакомьтесь с Универсальной общественной
%     лицензией GNU для получения более подробной информации.
% 
%     Вы должны были получить копию Универсальной общественной лицензии GNU
%     вместе с этой программой. Если Вы ее не получили, то перейдите по адресу:
%     <http://www.gnu.org/licenses/>.
% 
%     This program is free software: you can redistribute it and/or modify
%     it under the terms of the GNU General Public License as published by
%     the Free Software Foundation, either version 3 of the License, or
%     (at your option) any later version.
% 
%     This program is distributed in the hope that it will be useful,
%     but WITHOUT ANY WARRANTY; without even the implied warranty of
%     MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
%     GNU General Public License for more details.
% 
%     You should have received a copy of the GNU General Public License
%     along with this program.  If not, see <https://www.gnu.org/licenses/>.

function DB_Node_Move(Node_ID, New_Location)

% Если New_Location - столбец координат, то он предполагается в ГЛОБАЛЬНОЙ системе координат
% Если New_Location - номер существующего узла, то узел будет перемещен в соответствующую точку

global ErrCode;

global DB_NODES;
global DB_COORD;

global AT_NODES;
global AT_COORD;

global Cylindrical_CID_R_Tolerance;

% Проверка существования в базе узла
if (~DB_Node_Exist(Node_ID))
    fprintf (1, '\nОшибка функции DB_Node_Move: узел с номером %i отсутствует в базе !\n', Node_ID);
    ErrCode = -1;
    return;
end

% Проверка существования в базе референсного узла
if (size(New_Location,1) == 1)
    if (~DB_Node_Exist(New_Location))
        fprintf (1, '\nОшибка функции DB_Node_Move: референсный узел с номером %i отсутствует в базе !\n', New_Location);
        ErrCode = -1;
        return;
    end
end

% Новые координаты узла
if (size(New_Location,1) == 3)
	New_Global_Coordinates = New_Location;
else
    New_Global_Coordinates = DB_NODES{AT_NODES(New_Location)}.Location;
end

% Модификация записи в базе
if (DB_NODES{AT_NODES(Node_ID)}.Reference_CID == 0)
    
    DB_NODES{AT_NODES(Node_ID)}.Ref_Location = New_Global_Coordinates;
    
else
    
    switch DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.type
        
        case 'Rectangular'
            
            Local_XYZ = [DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.e_x, DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.e_y, DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.e_z] \ (New_Global_Coordinates - DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.origin);
            DB_NODES{AT_NODES(Node_ID)}.Ref_Location = Local_XYZ;
            
        case 'Cylindrical'
            
            Local_XYZ = [DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.e_r, DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.e_t, DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.e_z] \ (New_Global_Coordinates - DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.origin);
                        
            DB_NODES{AT_NODES(Node_ID)}.Ref_Location(1) = norm(Local_XYZ(1:2));
            
            if (DB_NODES{AT_NODES(Node_ID)}.Ref_Location(1) < Cylindrical_CID_R_Tolerance)
                DB_NODES{AT_NODES(Node_ID)}.Ref_Location(2) = 0;
            else
                DB_NODES{AT_NODES(Node_ID)}.Ref_Location(2) = acosd(Local_XYZ(1) / DB_NODES{AT_NODES(Node_ID)}.Ref_Location(1));
                if (Local_XYZ(2) < 0)
                    DB_NODES{AT_NODES(Node_ID)}.Ref_Location(2) = -DB_NODES{AT_NODES(Node_ID)}.Ref_Location(2);
                end
            end
            
            DB_NODES{AT_NODES(Node_ID)}.Ref_Location(3) = Local_XYZ(3);
            
        otherwise
            
            fprintf (1, '\nОшибка функции DB_Node_Move: тип [%s] системы координат с номером %i не поддерживается в текущей версии программы !\n', DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.type, DB_COORD{AT_COORD(DB_NODES{AT_NODES(Node_ID)}.Reference_CID)}.ID);
            fprintf (1, 'Обратитесь к разработчику для решения данного вопроса.\n');
            ErrCode = -1;
            return;
            
    end
    
end

DB_NODES{AT_NODES(Node_ID)}.Location = New_Global_Coordinates;
